From f0cc09ef6b313c17aec145a2408ec7355039f5b6 Mon Sep 17 00:00:00 2001
From: Stephen Gallagher <sgallagh@redhat.com>
Date: Thu, 18 Feb 2010 14:31:52 -0500
Subject: [PATCH 2/3] Fix licensing issues in SSSD

---
 server/providers/fail_over.h |   24 ++++++++++++++++++++++++
 server/tests/common.h        |   24 ++++++++++++++++++++++++
 server/util/refcount.h       |   24 ++++++++++++++++++++++++
 sss_client/protos.h          |   30 ++++++++++++++++++++++--------
 sss_client/sss_cli.h         |   30 ++++++++++++++++++++++--------
 sss_client/sss_pam_macros.h  |   30 ++++++++++++++++++++++--------
 6 files changed, 138 insertions(+), 24 deletions(-)

diff --git a/server/providers/fail_over.h b/server/providers/fail_over.h
index e581fba..f118483 100644
--- a/server/providers/fail_over.h
+++ b/server/providers/fail_over.h
@@ -1,3 +1,27 @@
+/*
+   SSSD
+
+   Fail over helper functions.
+
+   Authors:
+        Martin Nagy <mnagy@redhat.com>
+
+   Copyright (C) Red Hat, Inc 2009
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
 #ifndef __FAIL_OVER_H__
 #define __FAIL_OVER_H__
 
diff --git a/server/tests/common.h b/server/tests/common.h
index 0e954d7..5d4b086 100644
--- a/server/tests/common.h
+++ b/server/tests/common.h
@@ -1,3 +1,27 @@
+/*
+   SSSD
+
+   Common utilities for check-based tests using talloc.
+
+   Authors:
+        Martin Nagy <mnagy@redhat.com>
+
+   Copyright (C) Red Hat, Inc 2009
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
 #ifndef __TESTS_COMMON_H__
 #define __TESTS_COMMON_H__
 
diff --git a/server/util/refcount.h b/server/util/refcount.h
index cc99a17..3dd71cf 100644
--- a/server/util/refcount.h
+++ b/server/util/refcount.h
@@ -1,3 +1,27 @@
+/*
+   SSSD
+
+   Simple reference counting wrappers for talloc.
+
+   Authors:
+        Martin Nagy <mnagy@redhat.com>
+
+   Copyright (C) Red Hat, Inc 2009
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
 #ifndef __REFCOUNT_H__
 #define __REFCOUNT_H__
 
diff --git a/sss_client/protos.h b/sss_client/protos.h
index adb0b7b..ffc99e0 100644
--- a/sss_client/protos.h
+++ b/sss_client/protos.h
@@ -1,12 +1,26 @@
 /*
- * System Security Services Daemon. NSS Interface
- *
- * Copyright (C) Simo Sorce 2007
- *
- * You can used this header file in any way you see fit provided copyright
- * notices are preserved.
- *
- */
+   SSSD
+
+   Client Interface for NSS and PAM.
+
+   Authors:
+        Simo Sorce <ssorce@redhat.com>
+
+   Copyright (C) Red Hat, Inc 2007
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
 
 #if 0
 /* SHADOW database NSS interface */
diff --git a/sss_client/sss_cli.h b/sss_client/sss_cli.h
index 7e9a81f..ff222da 100644
--- a/sss_client/sss_cli.h
+++ b/sss_client/sss_cli.h
@@ -1,12 +1,26 @@
 /*
- * System Security Services Daemon. Client Interface for NSS and PAM.
- *
- * Copyright (C) Simo Sorce 2007
- *
- * You can used this header file in any way you see fit provided copyright
- * notices are preserved.
- *
- */
+   SSSD
+
+   Client Interface for NSS and PAM.
+
+   Authors:
+        Simo Sorce <ssorce@redhat.com>
+
+   Copyright (C) Red Hat, Inc 2007
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
 
 #ifndef _SSSCLI_H
 #define _SSSCLI_H
diff --git a/sss_client/sss_pam_macros.h b/sss_client/sss_pam_macros.h
index 5277acd..9e0f7bc 100644
--- a/sss_client/sss_pam_macros.h
+++ b/sss_client/sss_pam_macros.h
@@ -1,12 +1,26 @@
 /*
- * System Security Services Daemon. Client Interface for NSS and PAM.
- *
- * Copyright (C) Stephen Gallagher 2009
- *
- * You can used this header file in any way you see fit provided copyright
- * notices are preserved.
- *
- */
+   SSSD
+
+   Client Interface for NSS and PAM.
+
+   Authors:
+        Stephen Gallagher <sgallagh@redhat.com>
+
+   Copyright (C) Red Hat, Inc 2009
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
 
 #ifndef _SSS_PAM_MACROS_H
 #define _SSS_PAM_MACROS_H
-- 
1.6.6